--To clarify new APIs used are:
--love.physics (not the module but new/altered parts)
--Canvases (if supported)
--isSupported (to check if canvases can be used)

local q = nil
local qy = 0
local score = 0
local total = 0
local ammo = 8
local t = 8 -- start the timer at 8 seconds so the player has something to shoot at the beginning
local ducks = {
}
local sounds = {
laugh = love.audio.newSource("audio/Laugh.mp3","static"),
shot = love.audio.newSource("audio/Shot.mp3","static")
}

local bullet = love.graphics.newImage("images/Bullet.png")
local tree = love.graphics.newImage("images/Tree.png")
local mouse = love.graphics.newImage("images/Mouse.png")
local dog_IM = love.graphics.newImage("images/Dog.png")

local ducksprites = {
love.graphics.newImage("images/Duck1.png"),
love.graphics.newImage("images/Duck2.png")
}

local dog = {
laugh = false,
timer = 0,
}

function ducks:new()
local x = math.random(0,1)*900 - 50
local d = {
y = math.random(0,300),
x = x+math.random(-50,50),
dir = (x-425)/425 *-1,
speed = math.min(math.ceil(total/8),20)*20,
flying = true,
sprite = 1,
timer = 0,
rot = 0,
}
ducks[#ducks+1]=d
end

function love.load()
love.graphics.setIcon(love.graphics.newImage("images/Icon.png"))
love.mouse.setVisible(false)
	if love.graphics.isSupported("canvas") then
		canvas = love.graphics.newCanvas()
		love.graphics.setCanvas(canvas)
		love.graphics.setColor(0,255,0)
		love.graphics.rectangle("fill",0,300,800,200)
		love.graphics.setColor(0,0,255)
		love.graphics.rectangle("fill",0,0,800,400)
		love.graphics.setColor(255,255,255)
		love.graphics.draw(tree,0,180,0,2,2)
		--add more graphics if need be
		love.graphics.setCanvas()
	end
world = love.physics.newWorld(0,64,true)
love.physics.setMeter(64)
floor_body = love.physics.newBody(world,400,700,"static")
floor_shape = love.physics.newRectangleShape(0,0,800,200,45)
floor_fixture = love.physics.newFixture(floor_body,floor_shape)
tree_body = love.physics.newBody(world,69,300,"static")
tree_shape = love.physics.newRectangleShape(138,240)
tree_fixture = love.physics.newFixture(tree_body,tree_shape)
end

function love.draw()
	if canvas~=nil then -- slight FPS increase with canvases
		love.graphics.draw(canvas,0,0)
	else
		love.graphics.setColor(50,255,50)
		love.graphics.rectangle("fill",0,400,800,200)
		love.graphics.setColor(50,50,255)
		love.graphics.rectangle("fill",0,0,800,400)
		love.graphics.setColor(255,255,255)
		love.graphics.draw(tree,0,180,0,2,2)
	end
--Draw ducks
	for i=1,#ducks do
		love.graphics.draw(ducksprites[ducks[i].sprite],ducks[i].x,ducks[i].y,ducks[i].rot,ducks[i].dir*2,2)
	end
	for i=1,ammo do
		love.graphics.draw(bullet,50*i,550,0,5,5)
	end
	if dog.laugh then
		qy = 0
		if dog.timer<2 then
			qy = dog.timer/2 * 40
		elseif dog.timer<3 then
			qy = 40
		else
			qy = 40-((dog.timer-3)/2 * 40)
		end
		q = love.graphics.newQuad(0,0,29,qy,29,40)
		love.graphics.drawq(dog_IM,q,285,400-qy,0,2,2)
	end
	love.graphics.print("Next wave in: "..8-math.ceil(t),0,0)
	love.graphics.print("Score: "..score,100,0)
	love.graphics.draw(mouse,love.mouse.getX()-16,love.mouse.getY()-16)
end

function love.keypressed(k,u)
	if k=="escape" or k == "q" then
		love.event.push("q")
	end
end

function love.update(dt)
world:update(dt)
t=t+dt
total=total+dt
	if t>=8 and #ducks<20 then
		t = t-8 -- Carry over any extra time that elapsed eg. it took 8.1 seconds so the next loop is only 7.9 seconds long to account for it
		for i=1,math.random(3,8) do
			ducks:new()
		end
		ammo = 8
	end
	local tr = {} --To Remove
	for i=1,#ducks do
	ducks[i].timer = ducks[i].timer+dt
		if ducks[i].flying then
			ducks[i].x=ducks[i].x+ducks[i].dir*ducks[i].speed*dt
			
			if ducks[i].timer>=0.5 then
				ducks[i].sprite = (ducks[i].sprite-2)*-1+1
				ducks[i].timer=ducks[i].timer-0.5
			end
		else
			ducks[i].x = ducks[i].body:getX()
			ducks[i].y = ducks[i].body:getY()
			ducks[i].rot = ducks[i].body:getAngle()
			if ducks[i].timer>2 then
				tr[i] = i
			end
		end
	end
	for i=1,#tr do
		table.remove(ducks,tr[i])
	end
	if dog.laugh then
		dog.timer = dog.timer+dt
		if dog.timer>=5 then
			dog.timer = 0
			dog.laugh = false
		end
	end
end

function givePhysics(duck,n)
duck.body = love.physics.newBody(world,0,0,"dynamic")
duck.shape = love.physics.newRectangleShape(ducksprites[1]:getWidth()*2,ducksprites[1]:getHeight()*2)
duck.fixture = love.physics.newFixture(duck.body,duck.shape)
duck.body:setInertia(10)
duck.body:applyTorque(-40*duck.dir)
duck.body:applyForce(100,0)
duck.body:setX(duck.x)
duck.body:setY(duck.y)
end

function love.mousepressed(x,y,b)
local hit = false
	if b=="l" and ammo>0 then
		love.audio.play(sounds.shot)
		for i=1,#ducks do
			if ducks[i].dir==-1 then
				if ducks[i].x>x and ducks[i].y<y and ducks[i].x-ducksprites[1]:getWidth()*2<x and ducks[i].y+ducksprites[1]:getHeight()*2>y and ducks[i].flying then
					ducks[i].flying = false
					givePhysics(ducks[i],i)
					score = score+8
					hit = true
				end	
			else
				if ducks[i].x<x and ducks[i].y<y and ducks[i].x+ducksprites[1]:getWidth()*2>x and ducks[i].y+ducksprites[1]:getHeight()*2>y and ducks[i].flying then
					ducks[i].flying = false
					givePhysics(ducks[i],i)
					score = score+8
					hit = true
				end
			end
		end
	ammo=ammo-1
	if dog.laugh and x>285 and x<333 and y<400 and y>400-2*qy then --FINALY we can shoot that damn dog
		dog.timer = 5
		score = score + 8888
	end
	if not hit then
		love.audio.play(sounds.laugh)
		dog.laugh = true
	end
	end
end